#ifdef WIN32
#include "read4win.c"
#else
/*
 *	for new GOGO-no-coda (1999/09)
 *	Copyright (C) 1999 PEN@MarineCat, shigeo, Noisyu
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <limits.h>
#ifdef USE_BTHREAD
#include <OS.h>
#include <SupportDefs.h>
#include "haveunit.h"
#endif
#include "common.h"
#include "global.h"
#include "readsmpl.h"
#include "musenc.h"

#define		SAMPLE_LENGTH		2304
struct _SAMPLE_CONVERTER {
	unsigned long		pitch_lo, pitch_hi;
	unsigned long		pos_lo, pos_hi;
	unsigned long		pcmreadpos;
	unsigned long		fill_len;
	int					bFirstAttach;
	int					bHitEof;
	short				sample_org[ SAMPLE_LENGTH + 4];
	
	char				bPausedRead;
	unsigned long		pcmdecodepos;
	short				sample_decode[ SAMPLE_LENGTH ];
} samplecnverter;


extern struct MCP_INPDEV_USERFUNC	mc_userfunc;		// extern/[U[֐ݒ
extern unsigned long read_limitsize;

int		InitializeSampleConverter( int freq_in, int freq_out )
{
	double	pitch_tmp;
	if( freq_in <= 0 || freq_out <= 0){
		return FALSE;
	}
	memset( &samplecnverter, 0, sizeof( samplecnverter ) );
	if(freq_in == freq_out ){
	/* freqin == freqout̂Ƃ̓Ro[^[ʂȂǈꉞvZĂ */
		samplecnverter.pitch_hi = 1;
		samplecnverter.pitch_lo = 0;
	} else {
		samplecnverter.pitch_hi = freq_in / freq_out;
		if( freq_in >= freq_out ) freq_in %= freq_out;
		pitch_tmp = (double)freq_in * 4294967296. / (double)freq_out;
		samplecnverter.pitch_lo = (unsigned long)pitch_tmp;
	}

	samplecnverter.pcmreadpos   = -4 - SAMPLE_LENGTH;
	samplecnverter.bFirstAttach = TRUE;

	return TRUE;
}

/* wait for realtime-encoding by zin@jaist.ac.jp (00/02/22) */
static INLINE
size_t fread_nitems(
	void *buf,
	size_t size,
	size_t nitems,
	FILE *stream)
{
	size_t nread;

	nitems *= size;
	if( read_limitsize == ULONG_MAX ) {
		return fread( buf, 1, nitems, stream) / size;
	} else {
		nread = 0;
		if( read_limitsize < nitems )
			nitems = read_limitsize;
		if( nitems > 0 ){
			nread = fread( buf, 1, nitems , stream);
			if( nread > 0 )
				read_limitsize -= nread;
		} else {
			nread = 0;
		}
		return nread / size;
	}
}

static
unsigned long read_samples_sub(
	FILE *musicin,
	short		*sample_buffer,
	unsigned long frame_size)
{
	unsigned long samples_read;
	samples_read = frame_size;

	if( mc_userfunc.pUserFunc == MPGE_NULL_FUNC ){
		if( !bBitConvert ){
			// 16BIT PCM
			samples_read = fread_nitems(sample_buffer, sizeof(short), (int)samples_read, musicin);
#ifdef RAW_INPUT
			if( bSwapByte == TRUE ){
				int i;
				char low, high;
				for( i = 0; i < samples_read; i++ ){
					low = sample_buffer[i] & 0xFF;
					high = (unsigned)sample_buffer[i] >> 8;
					sample_buffer[i] = high + ( low << 8 );
				}
			}
#endif /* RAW_INPUT */
		} else {
			// 8BIT PCM
			int		i;
			unsigned char	org_buffer[4096];
			if ((samples_read =	fread_nitems(org_buffer, sizeof(char), (int)samples_read, musicin)) == 0){
				// HIT END OF DATA //

			}
			// 8BIT to 16BIT 
#ifdef RAW_INPUT
			if( bTownsSND ){
				for( i = 0; i < samples_read; i++ ){
					char data;
					data = org_buffer[i];
					if( data & 0x80 ){
						sample_buffer[i] = ((short)( data - 128 )) << 8;
					}else{
						sample_buffer[i] = ((short)( - data )) << 8;
					}
				}
			}else
#endif /* RAW_INPUT */
			for(i = 0;i < (signed)samples_read;i++){
				sample_buffer[i] = (org_buffer[i] - 128) << 8;
			}
		}
	} else {
		// [U[֐x[X
		if( !bBitConvert ){
			// 16BIT PCM
			memset( sample_buffer, 0, (int)samples_read * 2 );
			if ( mc_userfunc.pUserFunc( sample_buffer, (int)samples_read * 2) == ME_NOERR ){
				/* samples_read = samples_read * 2; */
			} else {
				samples_read = 0;
			}
		} else {
			// 8BIT PCM
			int		i;
			unsigned char	org_buffer[4096];
			memset( org_buffer, 0, (int)samples_read );
			if ( mc_userfunc.pUserFunc( org_buffer, (int)samples_read ) == ME_NOERR ){
			} else {
				samples_read = 0;
			}
			// 8BIT to 16BIT 
			for(i = 0;i < (signed)samples_read;i++)
				sample_buffer[i] = (org_buffer[i] - 128) << 8;
		}
	}
	if( samples_read < frame_size ){
		int	clr = samples_read;
		for (; clr < (signed)frame_size; sample_buffer[clr++] = 0);
	}

	return(samples_read);
}

static
int		getsample(unsigned long pos, FILE *musicin )
{
	if( (int)pos >= (int)(samplecnverter.pcmreadpos + samplecnverter.fill_len) ){
		int		readsamplenum;

		if( samplecnverter.bHitEof )
			return 0;				// ȍ~f[^

		*(long *)(&samplecnverter.sample_org[0]) = *(long *)(&samplecnverter.sample_org[SAMPLE_LENGTH    ]);
		*(long *)(&samplecnverter.sample_org[2]) = *(long *)(&samplecnverter.sample_org[SAMPLE_LENGTH + 2]);
		
		readsamplenum = read_samples_sub( musicin, samplecnverter.sample_org + 4, SAMPLE_LENGTH);
		if( readsamplenum != SAMPLE_LENGTH ){
			samplecnverter.bHitEof = TRUE;
		}
		samplecnverter.pcmreadpos += readsamplenum;
		samplecnverter.fill_len    = 4 + readsamplenum;

		return	getsample( pos, musicin );			// ċA
	}
	return samplecnverter.sample_org[ pos - samplecnverter.pcmreadpos];
}

static
unsigned long read_samples(
	FILE *musicin,
	short sample_buffer[2304],
	unsigned long frame_size,
	int chn)
{
	int		i;
	if( gl.enc_freqHz == gl.inp_freqHz ){
		// ̂܂܃X[
		return read_samples_sub( musicin, sample_buffer, frame_size );
	} else {
		if( samplecnverter.bHitEof && (samplecnverter.pos_hi * 2) >= samplecnverter.pcmreadpos + samplecnverter.fill_len ){
			memset( sample_buffer, 0, frame_size );
			return 0;				// ǂݍ݂łȂ
		}
		if( chn == 1 ){
			// MONO
			for(i = 0;i < (signed)frame_size;i++){
				int		s1, s2;
				int		pts;
				s1 = getsample( samplecnverter.pos_hi, musicin );
				if( samplecnverter.pos_lo == 0 ){
					sample_buffer[ i ] = s1 ;
				} else {
					pts = samplecnverter.pos_lo >> 17;
					s2 = getsample( samplecnverter.pos_hi + 1, musicin );
					sample_buffer[ i ] = (s1 * ( 0x8000 - pts ) + s2 * pts) >> 15;  
				}

				{
					unsigned long		org_low;
					org_low = samplecnverter.pos_lo;
					samplecnverter.pos_lo += samplecnverter.pitch_lo;
					if( samplecnverter.pos_lo < org_low ){
						samplecnverter.pos_hi += samplecnverter.pitch_hi + 1;
					} else {
						samplecnverter.pos_hi +=samplecnverter.pitch_hi;
					}
				}
			}
		} else {
			// STEREO
			for(i = 0;i < (signed)frame_size;i += 2){
				int		s1, s2, sa;
				int		pts;

				// LEFT 
				s1 = getsample( samplecnverter.pos_hi * 2, musicin );
				if( samplecnverter.pos_lo == 0 ){
					sample_buffer[ i ] = s1;
				} else {
					pts = samplecnverter.pos_lo >> 17;
					s2 = getsample( samplecnverter.pos_hi * 2 + 2, musicin );
					sa = s1 * ( 0x8000 - pts ) + s2 * pts; 
					sample_buffer[ i ] = sa >> 15;
				}

				// RIGHT
				s1 = getsample( samplecnverter.pos_hi * 2 + 1, musicin );
				if( samplecnverter.pos_lo == 0 ){
					sample_buffer[ i + 1 ] = s1;
				} else {
					pts = samplecnverter.pos_lo >> 17;
					s2 = getsample( samplecnverter.pos_hi * 2 + 3, musicin );
					sa = s1 * ( 0x8000 - pts ) + s2 * pts; 
					sample_buffer[ i + 1 ] = sa >> 15;
				}

				{
					unsigned long		org_low;
					org_low = samplecnverter.pos_lo;
					samplecnverter.pos_lo += samplecnverter.pitch_lo ;
					if( samplecnverter.pos_lo < org_low ){
						samplecnverter.pos_hi += samplecnverter.pitch_hi + 1;
					} else {
						samplecnverter.pos_hi +=samplecnverter.pitch_hi;
					}
				}
			}
		}
	}

	return frame_size;
}

#if defined(USE_BTHREAD)
static int maxthread_read = 0;
static int curthread_read = 0;
#endif

#if defined(USE_BTHREAD)
#define MAX_BUFFSIZE		30								/* 30ȏ͂܂Ȃ݂ */
#define READ_BLOCKSIZE	2304UL
#define MAX_READBUFF	READ_BLOCKSIZE * MAX_BUFFSIZE

static sem_id	mutex_read_audio;
static port_id	port_buf;
static port_id	empty_buf;
static short 	*pread = NULL;
static short 	*pwrite = NULL;
static short 	*plast = NULL;
static short 	*preadbuf = NULL;
static long 	bufremain = 0;
static thread_id	ptid_read;
FILE *cur_musicin;

static void *read_samples_thread(void *);
#endif

#if	defined(USE_BTHREAD)
static
void *
read_samples_thread(void *arg)		/* ǂ݃obt@݃Xbh */
#endif
#if	defined(USE_BTHREAD)
{
	unsigned long samples_read = 1;
	curthread_read = 1;
	do {
		/* TvORo[^[܂߂ă}`Xbh */
		if(bufremain < MAX_READBUFF) {	/* bufremain͕spӂɑƍ邪ACXbhł͌\Ȃ̂
									    Z}tHŕی삷KvȂ? */
									/* 30obt@ςɂȂ邱Ƃił͂Ȃ̂Łjif󃋁[v
									    Ƃ͂Ȃł傤iقƂHj */
			samples_read = read_samples(cur_musicin, pwrite, READ_BLOCKSIZE, 2);
			pwrite += samples_read;
			if((preadbuf + MAX_READBUFF) <= pwrite)
				pwrite = preadbuf;
			atomic_add(&bufremain,samples_read);		/* ւőZsiPOSIXł̓Z}tHŕی삵ȂĂ͂ȂȂj */
			write_port_etc(port_buf,0,0,0,B_TIMEOUT,0);		/* Ǎ݂ꂽ̂`B */
		} else {
			/* obt@ɂȂĐeɋN̂҂ */
			int32 j;
			read_port(empty_buf,&j,(void *)&j,0);
		}
	} while(samples_read > 0);
	curthread_read = 0;
	plast = pwrite;
	write_port(port_buf,0,0,0);	/* I` */
	return 0;
}
#endif

#if	defined(USE_BTHREAD)
/* ǂ݃obt@Ǎݕ */
static unsigned long
read_samples_mt(FILE *musicin, short *buffer, unsigned long frame_size, int chn)
{
	int32 readlast,j;
	/*  */
	if(!curthread_read && !maxthread_read) {
		/* Initilize semaphore / port */
		mutex_read_audio = create_sem(1,"read_audio");	/* {(mutex_frame)ی삳Ă邩炢ȂH */
		port_buf = create_port(1,"port_buf");	/* ݃XbhƂ̒ʐM|[gJ */
		empty_buf = create_port(1,"empty_buf");
	}
	/* GR[hXbhɑ΂郍bN͂ōs */
	acquire_sem(mutex_read_audio);
	if(!curthread_read && !maxthread_read) {
		int intpriority;
		/* create read buffer */
		preadbuf = (short *)malloc(MAX_READBUFF * 2);
		pread = preadbuf;
		pwrite = preadbuf;
		plast = NULL;
		bufremain = 0;		/* Z}tHKvȂ?(POSIXn͕Kv) */
		cur_musicin = musicin;
		/* create read thread */
		MPGE_getConfigure(MG_READTHREAD_PRIORITY,&intpriority);
		if((ptid_read = spawn_thread((thread_func)read_samples_thread,"gogoReadthread",intpriority,(void *)NULL)) > 0) {
			resume_thread(ptid_read);
			maxthread_read = 1;
		}
	}
	/* t@Cobt@̂҂ */
	while(bufremain < frame_size && plast == NULL) {	/* ŌȊOŕKvʂ̓ǂłȂ̂H */
		write_port_etc(empty_buf,0,0,0,B_TIMEOUT,0);	/* ȂƂ`Bi̕ӂ͉P̗]nLj */
										/* ܂AȂ̂͂ۂǓǍ݌xꍇ炢ł */
		read_port(port_buf,&j,(void *)&j,0);			/* ŒPǂݍ܂̂܂ */
	}
										/* posixnłpthread_cond_waitngĂ܂ƂɏĂ(..; */
	if(bufremain >= frame_size) {
		/* Get 1 block from the current buffer */
		readlast = (((unsigned long)pread - (unsigned long)preadbuf)) / 2 + frame_size;
		if(readlast <= MAX_READBUFF) {
			memcpy(buffer, pread, frame_size*sizeof(short));
			pread += frame_size;
			if(readlast == MAX_READBUFF)
				pread = preadbuf;
		} else {
			/* O */
			for ( j = 0; j < frame_size - (readlast - MAX_READBUFF); j++ ){
				buffer[j] = *pread++;
			}
			/* 㔼 */
			pread = preadbuf;
			for (; j < frame_size ; j++ ){
				buffer[j] = *pread++;
			}
		}
		atomic_add(&bufremain,-frame_size);	/* ւőZsiPOSIXł̓Z}tHŕی삵ȂĂ͂ȂȂj */
		release_sem(mutex_read_audio);
		return(frame_size);
	} else {
		/* ɗ_(Ȃ񂩂̌ŁjǍ݃Xbh͂ȂȂĂ */
		if(curthread_read && maxthread_read){
			/* ꉞXbhEĂ */
			kill_thread(ptid_read);
			curthread_read = 0;
		}
		if(bufremain > 0) {
			/* ݂̓ǂݎobt@PubNo */
			readlast = (((unsigned long)pread - (unsigned long)preadbuf)) / 2 + bufremain;
			if(readlast <= MAX_READBUFF) {
				for ( j = 0; j < bufremain; j++ ){
					*buffer++ = *pread++;
				}
			} else {
				/* O */
				for ( j = 0; j < bufremain - (readlast - MAX_READBUFF); j++ ){
					*buffer++ = *pread++;
				}
				/* 㔼 */
				pread = preadbuf;
				for (; j < bufremain; j++ ){
					*buffer++ = *pread++;
				}
			}
			for(;j < frame_size;j++) {
				*buffer++ = 0;
			}
		}
		j = atomic_add(&bufremain,-bufremain);
		/* Ƃ܂ */
		if(preadbuf != NULL)
			free(preadbuf);
		preadbuf = NULL;
		if(port_buf != 0)
			delete_port(port_buf);
		port_buf = 0;
		if(empty_buf != 0)
			delete_port(empty_buf);
		empty_buf = 0;
		if(mutex_read_audio != 0)
			delete_sem(mutex_read_audio);	/* Ĵ͑ɑ҂Xbh邩mȂ̂ōŌ */
		mutex_read_audio = 0;
		return( j );
	}
	return(0);
}
#endif

unsigned long
get_audio(FILE *musicin, short *buffer)
{
	unsigned long j, num, readNum;
	short insamp[1152*2];

	num = gl.frameSize;
	if( gl.stereo == 2 ){
		/* stereo -> stereo */
		/* No conversion needed, fall through... */
		return read_samples( musicin, buffer, num * 2, 2 );
	}
	if( bForceMono == FALSE ){
		/* mono -> mono */
		/* No conversion needed, fall through... */
		return read_samples( musicin, buffer, num, 1 );
	}

	/* stereo -> mono */
	readNum = read_samples( musicin, insamp, num * 2, 2 );
	for( j = 0; j < num; j++ ){
		buffer[j] = ( (int)insamp[j*2] + (int)insamp[j*2 + 1] ) / 2;
	}
	return readNum;
}

#if defined(USE_BTHREAD)
unsigned long
get_audio_thread(FILE *musicin, short *buffer)
{
	unsigned long j, num, readNum;
	short insamp[1152*2];

	num = gl.frameSize;
	if( gl.stereo == 2 ){
		/* stereo -> stereo */
		/* No conversion needed, fall through... */
		return read_samples_mt(musicin, buffer, num * 2, 2);
	}
	if( bForceMono == FALSE ){
		/* mono -> mono */
		/* No conversion needed, fall through... */
		return read_samples_mt( musicin, buffer, num, 1 );
	}

	/* stereo -> mono */
	readNum = read_samples_mt(musicin, insamp, num * 2, 2);
	for( j = 0; j < num; j++ ){
		buffer[j] = ( (int)insamp[j*2] + (int)insamp[j*2 + 1] ) / 2;
	}
	return readNum;
}
#endif
#endif /* WIN32 */
